/***
 * Ce fichier contient toutes les fonctions gnriques de la
 * gestion de la communication SOAP
 */

/***
 * Variable globale de type HashTablecontenant tous les time out
 *
 * Si je n'utilise pas un tableau c que je ne veut pas avoir un tableau plein de trou
 * je prefere avoir un hash qui par definition n'a pas de trou
 */

var txtSOAPCallTimeOut = {};
var objSOAPCallTimeOut = {};
var allSOAPCallIndex   = 0;

/***
 * Cette fonction sert a gerer le timeout
 */
function SOAPCallTimeOut(timeOutMessage){

	var newIndex = ++allSOAPCallIndex;
	var fct = "affSOAPCallTimeOut(\"" + newIndex + "\")";
	txtSOAPCallTimeOut[newIndex] = timeOutMessage;
	objSOAPCallTimeOut[newIndex] = setTimeout(fct, 10000);
	return newIndex;
}

function affSOAPCallTimeOut(index) {
	alert("Timeout " + txtSOAPCallTimeOut[index]);
	clearTimeout(objSOAPCallTimeOut[index]);
}

/***
 * Cette verifie la validit de la rponse SOAP
 */
function handleSOAPResponse(response, soapcall, error, timer, timeoutStr)
{
    clearTimeout(objSOAPCallTimeOut[timer]);

    if (error != 0 || !response) {	
	alert("Timeout " + timeoutStr);
	return false;
    } else {
	var fault = response.fault;
	if (fault != null) {
	    var code = fault.faultCode;
	    var msg = fault.faultString;
	    alert("SOAP FAULT:\n\n" + "Code: " + code + "\n\nMessage: " + msg);
	} else {
	    return response;
	}
    }
}

/*** 
 * Cette fonction ffectue l'appel SOAP en lui-mme 
 * Attention: Des lments sont cods en dur dans la fonction
 */
function dofanicall(method, params, callback, args)
{
	var host = glUrl;
	var port = glPort;
	if (!host || !port) {
		alert('Veuillez entrer une adresse et un port');
		return false;
	} else {
		uri = host + ":" + port;
		var pos = uri.search(/^http:\/\//);
		if (pos == -1) {
			alert("Veuillez entrer une URL valide");
  			return false;
  		}
 	}

	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch (e) {
		alert(e);
		return false;
	}

	var soapCall = new SOAPCall();
	soapCall.transportURI = uri;
	soapCall.encode(0, method, "urn:method-Fanibook", 0, null, params.length, params);

	var timer = SOAPCallTimeOut(args.timeoutStr);
	try {
		soapCall.asyncInvoke(
			function (response, soapcall, error) {
			        var r = handleSOAPResponse(response,soapcall,error, timer, args.timeoutStr);
				callback(r, args);
			}
		);

	} catch (e) {
		clearTimeout(objSOAPCallTimeOut[timer]);
		alert(e);
	}
	netscape.security.PrivilegeManager.revertPrivilege("UniversalBrowserRead");
}
